<template>
  <section class="section">
    <div class="columns">
      <div class="column is-6">
        <nav>
          <filter-dropdown
            type="year"
            :current="currents.year.toString()"
            :list="selects.years"
            @filter-results="setFilter"
          />
          <filter-dropdown
            type="month"
            :current="currents.month"
            :list="selects.months"
            @filter-results="setFilter"
          />
        </nav>
      </div>
    </div>
    <div class="columns">
      <div class="column is-5">
        <p
          v-if="displacements === null || displacements.length < 1"
          class="alert-message"
        >
          Aucunes courses réalisées en {{ currents.monthName }} {{ currents.year }}
        </p>
        <ul v-else>
          <li
            v-for="(displacement, index) in displacements"
            :key="index"
          >
            <ride-card
              v-if="displacement.passengersCount"
              :ride="displacement"
            />
            <shuttle-card
              v-else
              :shuttle="displacement"
            />
          </li>
        </ul>
      </div>
    </div>
  </section>
</template>

<script>
import { DateTime } from 'luxon';
import rideCard from '~/components/cards/ride.vue';
import shuttleCard from '~/components/cards/shuttle.vue';
import filterDropdown from '~/components/elements/filter-dropdown.vue';
import FilterManager from '~/helpers/filter-manager';

const filterManager = new FilterManager(2019);
const selects = filterManager.getSelects();
const currents = filterManager.getCurrents();

const RIDE_MASK = 'id,departure(label),arrival(label),start,luggage,passengersCount,status,campus';
const SHUTTLE_MASK = 'id,passengers,start,status,campus';

const formatData = (displacements) => displacements.map((displacement) => {
  const { day, hour } = (FilterManager.formatDate(displacement.createdAt));
  return {
    ...displacement,
    day,
    hour,
  };
});

export default {
  components: {
    rideCard,
    shuttleCard,
    filterDropdown,
  },
  async asyncData({ $api, $auth }) {
    const { start, end } = FilterManager.getFilter(currents);
    const [{ data: batchA }, { data: batchB }] = await Promise.all([
      $api.query('rides')
        .setMask(RIDE_MASK)
        .list(start, end)
        .setFilter('userId', $auth.user.id)
        .setFilter('current', false),
      $api.query('shuttles')
        .setMask(SHUTTLE_MASK)
        .list(start, end)
        .setFilter('passengerId', $auth.user.id)
        .setFilter('current', false),
    ]);

    return {
      displacements: [...formatData(batchA), ...formatData(batchB)].sort((a, b) => (a.start < b.start ? -1 : 1)),
    };
  },
  data() {
    return {
      selects,
      currents,
    };
  },
  methods: {
    setFilter({ key, value }) {
      this.currents = {
        ...this.currents,
        [key]: value,
      };
      this.currents.monthName = DateTime
        .local(parseInt(this.currents.year, 10), parseInt(this.currents.month, 10))
        .toLocaleString({ month: 'long' });
      this.fetchFilter();
    },
    async fetchFilter() {
      const { start, end } = FilterManager.getFilter(this.currents);
      const [{ data: batchA }, { data: batchB }] = await Promise.all([
        this.$api.query('rides')
          .setMask(RIDE_MASK)
          .list(start, end)
          .setFilter('userId', this.$auth.user.id)
          .setFilter('current', false),
        this.$api.query('shuttles')
          .setMask(SHUTTLE_MASK)
          .list(start, end)
          .setFilter('passengerId', this.$auth.user.id)
          .setFilter('current', false),
      ]);

      this.displacements = [...formatData(batchA), ...formatData(batchB)].sort((a, b) => (a.start < b.start ? -1 : 1));
    },
  },
};
</script>
